diff --git a/packages/finish-install/finish-install.d/90console b/packages/finish-install/finish-install.d/90console
index 2fd6e2f..fd2a38d 100755
--- a/packages/finish-install/finish-install.d/90console
+++ b/packages/finish-install/finish-install.d/90console
@@ -5,6 +5,14 @@ log() {
 	logger -t finish-install "$@"
 }
 
+avoid_duplication() {
+	if ! grep -q "$1" "$2"; then
+		echo "" >> "$2"
+		echo "# serial console added by debian-installer" >> "$2"
+		echo "$1" >> "$2"
+	fi
+}		
+
 # Since this script is running with debconf, 'tty' does
 # not give reliable answers about what sort of terminal
 # we have.  The stdin of /sbin/debian-installer seems
@@ -39,11 +47,9 @@ case "$console" in
 		    /target/etc/event.d/tty1 > /target/etc/event.d/$console
 	fi
 
-	echo "" >> /target/etc/securetty
-	echo "# serial console added by debian-installer" >> /target/etc/securetty
-	echo "$rawconsole" >> /target/etc/securetty
+	avoid_duplication "$rawconsole" /target/etc/securetty
 	if [ -n "$console" ] && [ "$console" != "$rawconsole" ]; then
-		echo "$console" >> /target/etc/securetty
+		avoid_duplication "$console" /target/etc/securetty
 	fi
 	;;
 esac
